/*!
 * @file network_stream.h
 *  implementation of a network pipe
 */

#ifndef _NETWORK_STREAM
#define _NETWORK_STREAM

#include "data_stream.h"

class Synchronizeable;
class NetworkSocket;
class ConnectionMonitor;

class NetworkStream : public virtual DataStream
{

public:
  NetworkStream();
  NetworkStream(DataStream& inStream, DataStream& outStream);
  NetworkStream(Synchronizeable& sync, NetworkSocket& socket);
  NetworkStream(DataStream& inStream, NetworkSocket& socket);
  NetworkStream(Synchronizeable& sync, DataStream& outStream);
  
  ~NetworkStream();
   
  void init();
  
  virtual void processData();

private:
  //NetworkProtocol* networkProtocol;
  NetworkSocket*	  networkSockets;
  ConnectionMonitor*      connectionMonitor;
 // tList<Synchronizeable>* synchronizeables;
  Synchronizeable* 	    synchronizeables;
};
#endif /* _NETWORK_STREAM */

